var ootliner = (function () {
  'use strict';

  function styleInject(css, ref) {
    if ( ref === void 0 ) ref = {};
    var insertAt = ref.insertAt;

    if (!css || typeof document === 'undefined') { return; }

    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';

    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css = "/* Styles that will be ported to javascript gen. eventually. */\n\n\n\n@-webkit-keyframes outline_mini_enter {\n  0% { left: -100px; }\n  100% { left: 0px; }\n}\n\n\n\n@keyframes outline_mini_enter {\n  0% { left: -100px; }\n  100% { left: 0px; }\n}\n\n.oot_base {\n  max-height: 70vh;\n  overflow-y: scroll;\n  padding-right: 24px !important;\n}\n\n.oot_outline_expanded {\n  color:         #333;\n  left:          0;\n  padding: 32px 8px 32px 8px !important;\n  position:      fixed;\n  top:           30%;\n  opacity:       1;\n  -webkit-animation: outline_mini_enter 0.4s ease;\n          animation: outline_mini_enter 0.4s ease;\n}\n\n.oot_outline_expanded_hide {\n  color:         #333;\n  left:          -100px !important;\n  padding: 32px 8px 32px 8px !important;\n  position:      fixed;\n  top:           30%;\n  opacity:       0;\n  -webkit-transition:   all 0.4s ease;\n  -o-transition:   all 0.4s ease;\n  transition:   all 0.4s ease;\n}\n\n.oot_outline_mini {\n  -webkit-transition: all 0.2s ease;\n  -o-transition: all 0.2s ease;\n  transition: all 0.2s ease;\n  color:         #333;\n  padding: 32px 8px 32px 0px !important;\n  left:          0;\n  position:      fixed;\n  top:           30%;\n  -webkit-animation-name: outline_mini_enter;\n          animation-name: outline_mini_enter;\n  -webkit-animation-duration: 0.4s;\n          animation-duration: 0.4s;\n}\n\n\n/* Base heading class */\n.oot_base_class {\n  font-family:     \"arial\";\n  list-style-type: none;\n  padding:         4px;\n  cursor:          pointer;\n  max-width:       500px;\n  padding-top:     6px;\n  padding-bottom:  6px;\n}\n\n.oot_base_class:hover {\n  color: #0070E0;\n}\n\n\n/* Heading specific styles; when in `mini` mode. */\n.oot_h_mini {\n  padding-left: 0 !important;\n}\n\n.oot_h1 {\n  font-size: 0.8rem;\n  font-weight: bold;\n}\n\n.oot_h2 {\n  font-size: 0.8rem;\n  font-weight: 400;\n  padding-left: 1rem;\n\n}\n\n.oot_h3 {\n  font-size: 0.8rem;\n  padding-left: 2rem;\n}\n\n.oot_h4 {\n  font-size: 0.7rem;\n  padding-left: 3rem;\n\n}\n\n.oot_h5 {\n  font-size: 0.7rem;\n  padding-left: 3rem;\n}\n\n.oot_h6 {\n  font-size: 0.7rem;\n  padding-left: 3rem;\n}\n";
  styleInject(css);

  var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  /**
   * lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="npm" -o ./`
   * Copyright jQuery Foundation and other contributors <https://jquery.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   */

  /** Used as the `TypeError` message for "Functions" methods. */
  var FUNC_ERROR_TEXT = 'Expected a function';

  /** Used as references for various `Number` constants. */
  var NAN = 0 / 0;

  /** `Object#toString` result references. */
  var symbolTag = '[object Symbol]';

  /** Used to match leading and trailing whitespace. */
  var reTrim = /^\s+|\s+$/g;

  /** Used to detect bad signed hexadecimal string values. */
  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

  /** Used to detect binary string values. */
  var reIsBinary = /^0b[01]+$/i;

  /** Used to detect octal string values. */
  var reIsOctal = /^0o[0-7]+$/i;

  /** Built-in method references without a dependency on `root`. */
  var freeParseInt = parseInt;

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = freeGlobal || freeSelf || Function('return this')();

  /** Used for built-in method references. */
  var objectProto = Object.prototype;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var objectToString = objectProto.toString;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeMax = Math.max,
      nativeMin = Math.min;

  /**
   * Gets the timestamp of the number of milliseconds that have elapsed since
   * the Unix epoch (1 January 1970 00:00:00 UTC).
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Date
   * @returns {number} Returns the timestamp.
   * @example
   *
   * _.defer(function(stamp) {
   *   console.log(_.now() - stamp);
   * }, _.now());
   * // => Logs the number of milliseconds it took for the deferred invocation.
   */
  var now = function() {
    return root.Date.now();
  };

  /**
   * Creates a debounced function that delays invoking `func` until after `wait`
   * milliseconds have elapsed since the last time the debounced function was
   * invoked. The debounced function comes with a `cancel` method to cancel
   * delayed `func` invocations and a `flush` method to immediately invoke them.
   * Provide `options` to indicate whether `func` should be invoked on the
   * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
   * with the last arguments provided to the debounced function. Subsequent
   * calls to the debounced function return the result of the last `func`
   * invocation.
   *
   * **Note:** If `leading` and `trailing` options are `true`, `func` is
   * invoked on the trailing edge of the timeout only if the debounced function
   * is invoked more than once during the `wait` timeout.
   *
   * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
   * until to the next tick, similar to `setTimeout` with a timeout of `0`.
   *
   * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
   * for details over the differences between `_.debounce` and `_.throttle`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to debounce.
   * @param {number} [wait=0] The number of milliseconds to delay.
   * @param {Object} [options={}] The options object.
   * @param {boolean} [options.leading=false]
   *  Specify invoking on the leading edge of the timeout.
   * @param {number} [options.maxWait]
   *  The maximum time `func` is allowed to be delayed before it's invoked.
   * @param {boolean} [options.trailing=true]
   *  Specify invoking on the trailing edge of the timeout.
   * @returns {Function} Returns the new debounced function.
   * @example
   *
   * // Avoid costly calculations while the window size is in flux.
   * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
   *
   * // Invoke `sendMail` when clicked, debouncing subsequent calls.
   * jQuery(element).on('click', _.debounce(sendMail, 300, {
   *   'leading': true,
   *   'trailing': false
   * }));
   *
   * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
   * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
   * var source = new EventSource('/stream');
   * jQuery(source).on('message', debounced);
   *
   * // Cancel the trailing debounced invocation.
   * jQuery(window).on('popstate', debounced.cancel);
   */
  function debounce(func, wait, options) {
    var lastArgs,
        lastThis,
        maxWait,
        result,
        timerId,
        lastCallTime,
        lastInvokeTime = 0,
        leading = false,
        maxing = false,
        trailing = true;

    if (typeof func != 'function') {
      throw new TypeError(FUNC_ERROR_TEXT);
    }
    wait = toNumber(wait) || 0;
    if (isObject(options)) {
      leading = !!options.leading;
      maxing = 'maxWait' in options;
      maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
      trailing = 'trailing' in options ? !!options.trailing : trailing;
    }

    function invokeFunc(time) {
      var args = lastArgs,
          thisArg = lastThis;

      lastArgs = lastThis = undefined;
      lastInvokeTime = time;
      result = func.apply(thisArg, args);
      return result;
    }

    function leadingEdge(time) {
      // Reset any `maxWait` timer.
      lastInvokeTime = time;
      // Start the timer for the trailing edge.
      timerId = setTimeout(timerExpired, wait);
      // Invoke the leading edge.
      return leading ? invokeFunc(time) : result;
    }

    function remainingWait(time) {
      var timeSinceLastCall = time - lastCallTime,
          timeSinceLastInvoke = time - lastInvokeTime,
          result = wait - timeSinceLastCall;

      return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
    }

    function shouldInvoke(time) {
      var timeSinceLastCall = time - lastCallTime,
          timeSinceLastInvoke = time - lastInvokeTime;

      // Either this is the first call, activity has stopped and we're at the
      // trailing edge, the system time has gone backwards and we're treating
      // it as the trailing edge, or we've hit the `maxWait` limit.
      return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
        (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
    }

    function timerExpired() {
      var time = now();
      if (shouldInvoke(time)) {
        return trailingEdge(time);
      }
      // Restart the timer.
      timerId = setTimeout(timerExpired, remainingWait(time));
    }

    function trailingEdge(time) {
      timerId = undefined;

      // Only invoke if we have `lastArgs` which means `func` has been
      // debounced at least once.
      if (trailing && lastArgs) {
        return invokeFunc(time);
      }
      lastArgs = lastThis = undefined;
      return result;
    }

    function cancel() {
      if (timerId !== undefined) {
        clearTimeout(timerId);
      }
      lastInvokeTime = 0;
      lastArgs = lastCallTime = lastThis = timerId = undefined;
    }

    function flush() {
      return timerId === undefined ? result : trailingEdge(now());
    }

    function debounced() {
      var time = now(),
          isInvoking = shouldInvoke(time);

      lastArgs = arguments;
      lastThis = this;
      lastCallTime = time;

      if (isInvoking) {
        if (timerId === undefined) {
          return leadingEdge(lastCallTime);
        }
        if (maxing) {
          // Handle invocations in a tight loop.
          timerId = setTimeout(timerExpired, wait);
          return invokeFunc(lastCallTime);
        }
      }
      if (timerId === undefined) {
        timerId = setTimeout(timerExpired, wait);
      }
      return result;
    }
    debounced.cancel = cancel;
    debounced.flush = flush;
    return debounced;
  }

  /**
   * Creates a throttled function that only invokes `func` at most once per
   * every `wait` milliseconds. The throttled function comes with a `cancel`
   * method to cancel delayed `func` invocations and a `flush` method to
   * immediately invoke them. Provide `options` to indicate whether `func`
   * should be invoked on the leading and/or trailing edge of the `wait`
   * timeout. The `func` is invoked with the last arguments provided to the
   * throttled function. Subsequent calls to the throttled function return the
   * result of the last `func` invocation.
   *
   * **Note:** If `leading` and `trailing` options are `true`, `func` is
   * invoked on the trailing edge of the timeout only if the throttled function
   * is invoked more than once during the `wait` timeout.
   *
   * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
   * until to the next tick, similar to `setTimeout` with a timeout of `0`.
   *
   * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
   * for details over the differences between `_.throttle` and `_.debounce`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to throttle.
   * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
   * @param {Object} [options={}] The options object.
   * @param {boolean} [options.leading=true]
   *  Specify invoking on the leading edge of the timeout.
   * @param {boolean} [options.trailing=true]
   *  Specify invoking on the trailing edge of the timeout.
   * @returns {Function} Returns the new throttled function.
   * @example
   *
   * // Avoid excessively updating the position while scrolling.
   * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
   *
   * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
   * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
   * jQuery(element).on('click', throttled);
   *
   * // Cancel the trailing throttled invocation.
   * jQuery(window).on('popstate', throttled.cancel);
   */
  function throttle(func, wait, options) {
    var leading = true,
        trailing = true;

    if (typeof func != 'function') {
      throw new TypeError(FUNC_ERROR_TEXT);
    }
    if (isObject(options)) {
      leading = 'leading' in options ? !!options.leading : leading;
      trailing = 'trailing' in options ? !!options.trailing : trailing;
    }
    return debounce(func, wait, {
      'leading': leading,
      'maxWait': wait,
      'trailing': trailing
    });
  }

  /**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */
  function isObject(value) {
    var type = typeof value;
    return !!value && (type == 'object' || type == 'function');
  }

  /**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */
  function isObjectLike(value) {
    return !!value && typeof value == 'object';
  }

  /**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */
  function isSymbol(value) {
    return typeof value == 'symbol' ||
      (isObjectLike(value) && objectToString.call(value) == symbolTag);
  }

  /**
   * Converts `value` to a number.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {number} Returns the number.
   * @example
   *
   * _.toNumber(3.2);
   * // => 3.2
   *
   * _.toNumber(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toNumber(Infinity);
   * // => Infinity
   *
   * _.toNumber('3.2');
   * // => 3.2
   */
  function toNumber(value) {
    if (typeof value == 'number') {
      return value;
    }
    if (isSymbol(value)) {
      return NAN;
    }
    if (isObject(value)) {
      var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
      value = isObject(other) ? (other + '') : other;
    }
    if (typeof value != 'string') {
      return value === 0 ? value : +value;
    }
    value = value.replace(reTrim, '');
    var isBinary = reIsBinary.test(value);
    return (isBinary || reIsOctal.test(value))
      ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
      : (reIsBadHex.test(value) ? NAN : +value);
  }

  var lodash_throttle = throttle;

  var els = document.querySelectorAll("h1, h2, h3, h4, h5, h6");
  var outlineDS = [];
  var outlineOpening = false;
  var outlineClosing = false;
  var n = document.createElement("UL");                    // the main <ul> of the outline.


  /**
   * init builds the outline container for the entire outline.
   * then, it searches for all header tags and runs CreateOutlineItem forEach.
   */
  function init() {
    n.classList = "oot_base oot_outline_mini";               // initial starting class (start "closed")
    els.forEach(e => {                                       // loop through the headings
      e.id ? e.id : (e.id = e.textContent);                  // set an id if the element doesn't have one.
      n.appendChild(CreateOutlineItem(e));                   // send the element to be turned into a list item.
      outlineDS.push(e.textContent);                         // put text contents into datastructure
    });

    document.body.appendChild(n);                            // Graft that shit onto your fully sick site.
    transformMode(n, "mini");                                // Start in mini mode.
    n.addEventListener("mouseenter", lodash_throttle(openMenu, 400));
    n.addEventListener("mouseleave", lodash_throttle(closeMenu, 400));
  }

  /**
   * Sets the classes to close the menu and changes the list item text to dashes.
   */
  function closeMenu() {
    if (outlineOpening) {
      setTimeout(() => closeMenu(), 400);                // The menu is currently opening, try again in 400ms.
    } else {
      outlineClosing = true;                                 // The menu is closing now, so let's
      n.classList = "oot_base oot_outline_expanded_hide"; // remove class so we can do:
      void n.offsetWidth;                                 // hack to recalculate css to trigger animation.
      setTimeout(() => {
        n.classList = "oot_base oot_outline_mini";        // initial starting class
        transformMode(n, "mini");
        outlineClosing = false;
      }, 400);
    }
  }

  /**
   * Sets css classes to open the Ootliner.
   * After 400ms, set outlineOpening to false.
   */
  function openMenu() {
    if (outlineClosing) {
      setTimeout(() => openMenu(), 400);                // The menu is currently opening, try again in 400ms.
    } else {
      outlineOpening = true;
      n.classList = "oot_base";                           // remove class so we can do:
      void n.offsetWidth;                                 // hack to recalculate css to trigger animation.
      n.classList = "oot_base oot_outline_expanded";      // initial starting class
      transformMode(n, "full");                           // convert outline items to their text headings.
      setTimeout(() => {
        outlineOpening = false;
      }, 400);                                               // done opening, set it to false
    }
  }

  /**
   * Alters the outline based on mouse position:
   * ie: mouse enters -> loop overall dom elements
   * if mode == mini  -> update <li>'s -> to oot_h_mini -> (shrink 'em, move flush to window left)
   * if mode == full  -> remove the `oot_h_mini` class and re-add the text contents of the <li>
   */
  function transformMode(outline, mode) {
    var items = Array.from(outline.children);
    var fmt = (el, dash) => {
      el.textContent = dash;
    };
    var hasH = (el, h) => el.classList.contains("oot_" + h);

    if (mode == "mini") {
      items.forEach(el => {
        if (hasH(el, "h1") || hasH(el, "h2")) {
          el.classList.add("oot_h_mini");
          fmt(el, "—");
        } else {
          el.classList.add("oot_h_mini");
          fmt(el, "‐");
        }
      });
    }

    if (mode == "full") {
      items.forEach((el, idx) => {
        el.classList.remove("oot_h_mini");
        fmt(el, outlineDS[idx]);
      });
    }
  }

  /**
   * createOutlineItem receives a heading node and makes a LI node for it.
   */
  function CreateOutlineItem(e) {
    let node = document.createElement("LI");
    node.setAttribute("class", "oot_base_class " + applyStyling(e.tagName));
    node.onclick = () => jumpToHeading(e.id);
    node.textContent = e.textContent;
    return node;
  }

  /**
   * jumpToHeading takes the outlineItem clicked and scrolls to it on the page.
   */
  function jumpToHeading(id) {
    var x = document.getElementById(id);
    x.scrollIntoView({ behavior: "smooth" });
  }

  function applyStyling(elType) {
    switch (elType) {
      case "H1":
        return `oot_h1`;
      case "H2":
        return `oot_h2`;
      case "H3":
        return `oot_h3`;
      case "H4":
        return `oot_h4`;
      case "H5":
        return `oot_h5`;
      case "H6":
        return `oot_h6`;
      default:
        return ``;
    }
  }

  return init;

}());

export default ootliner;
